%define		_ooodir		/opt/libreoffice%{version}
%define		_gengal		%{_ooodir}/program/gengal
%define		_ooogaldir	%{_ooodir}/share/gallery

%bcond_without	tarball		# don't use tarball, build gallery

Name:           libreoffice-openclipart
Summary:        Extra Galleries for libreoffice
Summary(de):	Extra-Galerien für libreoffice
Version:		24.2
Release:	%mkrel 1
License:	GPL v2 or later; LGPL v2.1 or later
Group:          Office
Source0:	    openoffice.org-openclipart-0.18.tar.xz
URL:            http://www.openoffice.org/
Conflicts:	openoffice.org3-openclipart
Provides:       libreoffice-galleries = %version
Requires:  	clipart-openclipart >= 0.18
%if %{without tarball}
BuildRequires:	x11-server-xvfb
BuildRequires:  libreoffice%{version}
BuildRequires:  libobasis%{version}-graphicfilter
BuildRequires:  clipart-openclipart
BuildRequires:  update-alternatives
Conflicts:	openoffice.org3-openclipart
Requires:  	clipart-openclipart >= 0.18
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This package contains an extensive set of extra galleries for
libreoffice. It can be used to enrich documents with graphics arts.

%description -l de
Dieses Paket enthält eine umfangreiche Reihe von zusätzlichen Galerien für
libreoffice. Es kann verwendet werden, um Dokumente mit Grafiken zu bereichern.

%prep
%if %{with tarball}
%setup -q -n openoffice.org-openclipart-0.18
%else
%setup -q -c -T -n openoffice.org-openclipart-0.18
%endif

%if %{without tarball}
%build
OPENCLIPART_DIR=%{_datadir}/images/openclipart
GAL_BIN=%{_gengal}
GAL_DIR=$(pwd)/gallery
# start number for the new galleries
GAL_NUMBER_FROM=70
XVFB=/usr/bin/Xvfb

XDISPLAY=98
echo 'Starting Xvfb...'
# try only 10-times to avoid infinite loop
while [ "$XDISPLAY" != 108 ]; do
	if [ ! -f /tmp/.X$XDISPLAY-lock ]; then
		echo "	trying display :$XDISPLAY ..."
		sleep 2s
		$XVFB -ac :$XDISPLAY &
		trap "kill $! > /dev/null 2>&1 || true" EXIT
		# let server to start
		sleep 10s
		if [ -f /tmp/.X$XDISPLAY-lock ]; then
			break
		fi
	fi
	XDISPLAY=$(($XDISPLAY+1))
done

if ! test -f /tmp/.X$XDISPLAY-lock ; then
	echo "Error: Unable to start Xvfb" >&2
	exit 1
fi

export DISPLAY=":$XDISPLAY"
echo "Using DISPLAY="$DISPLAY

rm -rf $GAL_DIR
mkdir -p $GAL_DIR
echo "Building extra galleries from openclipart..."
for dir in $(find -L $OPENCLIPART_DIR -mindepth 1 -maxdepth 1 -type d | sort); do
	# get the gallery name from the directory name
	# and make the first character uppercase
	gal_name=${dir##*/}
	gal_name=$(echo $gal_name | tr '_-' '  ')
	gal_name_rest=${gal_name#?}
	gal_name_first_char=${gal_name%$gal_name_rest}
	gal_name_first_char=$(echo $gal_name_first_char | tr 'a-z' 'A-Z')
	gal_name=$gal_name_first_char$gal_name_rest

	echo "Doing gallery $gal_name..."
	find $dir -name '*.png' -print0 | sort -z | {
		xargs -0 $GAL_BIN \
			--name "$gal_name" \
			--path "$GAL_DIR" \
			--number-from "$GAL_NUMBER_FROM" || exit 1
	}
done
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_ooogaldir}
cp -a gallery/* $RPM_BUILD_ROOT%{_ooogaldir}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%{_ooogaldir}/*

%changelog
* Thu Feb 01 2024 pp <pp> 24.2-1pclos2024
- new version

* Mon Aug 14 2023 pp <pp> 7.6-1pclos2023
- new version

* Sun Jan 29 2023 pp <pp> 7.5-1pclos2023
- new version

* Sat Jan 29 2022 pp <pp> 7.3-1pclos2022
- new version

* Tue Aug 17 2021 pp <pp> 7.2-1pclos2021
- update

* Sat Jan 30 2021 pp <pp> 7.1-1pclos2021
- update

* Sat Aug 01 2020 pp <pp> 7.0-1pclos2020
- update

* Fri Jan 24 2020 pp <pp> 6.4-1pclos2020
- update

* Fri Aug 09 2019 pp <pp> 6.3-2pclos2019
- remove Requires libreoffice to allow upgrade via lomanager

* Sat Aug 03 2019 pp <pp> 6.3-1pclos2019
- update

* Fri Feb 01 2019 pp <pp> 6.2-1pclos2019
- update

* Sat Aug 04 2018 pp <pp> 6.1-1pclos2018
- update

* Sat Jan 27 2018 pp <pp> 6.0-1pclos2018
- update

* Sun Jul 23 2017 pp <pp> 5.4-1pclos2017
- update
- removed noarch

* Sat Jan 28 2017 pp <pp> 5.3-1pclos2017
- update

* Mon Aug 01 2016 pp <pp> 5.2-1pclos2016
- update

* Sun Jan 31 2016 pp <pp> 5.1-1pclos2016
- 5.1

* Sat Aug 08 2015 pp <pp> 5.0-1pclos2015
- 5.0
